package com.vseravno.solna.adapter;

import javax.annotation.Nonnull;
import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.transform.*;
import javax.xml.transform.stax.StAXSource;

public class TransformUtils {
    private static final TransformerFactory transformerFactory;

    static {
        System.setProperty("javax.xml.transform.TransformerFactory",
                "com.sun.org.apache.xalan.internal.xsltc.trax.TransformerFactoryImpl");

        transformerFactory = TransformerFactory.newInstance();
    }

    public static void transform(@Nonnull XMLEventReader reader, @Nonnull Result result) throws XMLStreamException, TransformerException {
        transform(new StAXSource(reader), result);
    }

    public static void transform(@Nonnull Source source, @Nonnull Result result) throws TransformerException {
        Transformer transformer = transformerFactory.newTransformer();
        transformer.transform(source, result);
    }
}
