package com.vseravno.solna.parser;

import javax.annotation.Nonnull;
import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.XMLEvent;
import java.util.List;
import java.util.ListIterator;

public class ListXmlEventReader implements XMLEventReader {
    private ListIterator<XMLEvent> iterator;

    private XMLEventReader originReader;

    public ListXmlEventReader(@Nonnull List<XMLEvent> events, @Nonnull XMLEventReader originReader) {
        this.iterator = events.listIterator();
        this.originReader = originReader;
    }

    @Override
    public XMLEvent nextEvent() throws XMLStreamException {
        return iterator.next();
    }

    @Override
    public boolean hasNext() {
        return iterator.hasNext();
    }

    @Override
    public Object next() {
        return iterator.next();
    }

    @Override
    public void remove() {
        iterator.remove();
    }

    @Override
    public XMLEvent peek() throws XMLStreamException {
        XMLEvent event = iterator.next();
        iterator.previous();
        return event;
    }

    @Override
    public String getElementText() throws XMLStreamException {
        throw new UnsupportedOperationException();
    }

    @Override
    public XMLEvent nextTag() throws XMLStreamException {
        throw new UnsupportedOperationException();
    }

    @Override
    public Object getProperty(String name) throws IllegalArgumentException {
        return originReader.getProperty(name);
    }

    @Override
    public void close() throws XMLStreamException {
    }
}
